<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<title>Introduction to rdb.report • rdb.report</title>
<script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet">
<script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet">
<link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet">
<script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Introduction to rdb.report">
<meta name="robots" content="noindex">
<script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script>
</head>
<body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">rdb.report</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9016</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto">
<li class="active nav-item"><a class="nav-link" href="../articles/rdb-report.html">Get started</a></li>
<li class="nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
      </ul>
<ul class="navbar-nav">
<li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json">
</form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/zdaarau/rpkgs/rdb.report/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch">
<li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul>
</li>
      </ul>
</div>


  </div>
</nav><div class="container template-article">




<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Introduction to rdb.report</h1>
            
      
      <small class="dont-index">Source: <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/blob/HEAD/vignettes/rdb-report.Rmd" class="external-link"><code>vignettes/rdb-report.Rmd</code></a></small>
      <div class="d-none name"><code>rdb-report.Rmd</code></div>
    </div>

    
    
<div class="section level2">
<h2 id="organisation">Organisation<a class="anchor" aria-label="anchor" href="#organisation"></a>
</h2>
<p>This R package bundles together code and configuration to produce the
yearly Referendum Database (RDB) report <a href="https://report.rdb.vote/" class="external-link"><em>World of Referendums</em></a>,
including:</p>
<ul>
<li>The Quarto project sources (under <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/" class="external-link"><code>input/report/</code></a>).</li>
<li>R code tailored to the RDB report (under the repository root),
i.e. as the sources of the dedicated R package
<code>rdb.report</code>.</li>
<li>Input files generated via functions from the <code>rdb.report</code>
package like <a href="https://rdb.report.rpkg.dev/reference/preassemble"><code>rdb.report::preassemble()</code></a>
(under <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/generated/" class="external-link"><code>input/generated/</code></a>).</li>
<li>The generated Quarto output (under <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/output/report/" class="external-link"><code>output/report/</code></a>),
which is directly deployed from the <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/tree/master/output/report/" class="external-link">GitLab
repository’s <code>master</code> branch</a> to <a href="https://report.rdb.vote/" class="external-link">report.rdb.vote</a> via <a href="https://app.netlify.com/sites/report-rdb-vote/deploys" class="external-link">Netlify</a>.</li>
</ul>
<p>Besides the GitLab repository <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report" class="external-link"><code>zdaarau/rpkgs/rdb.report</code></a>
that contains this very R package, we use</p>
<ul>
<li><p>the GitLab repository <a href="https://gitlab.com/zdaarau/meta/rdb/" class="external-link"><strong><code>zdaarau/meta/rdb</code></strong></a>
to collect <a href="https://gitlab.com/zdaarau/meta/rdb/-/issues" class="external-link">issues</a> around
the RDB that are not directly related to specific code but generally
apply to the RDB data or structure. The repository is public.</p></li>
<li><p>a dedicated SWITCHDrive (<a href="https://en.wikipedia.org/wiki/OwnCloud" class="external-link">ownCloud</a>) folder <a href="https://drive.switch.ch/index.php/f/6665935856" class="external-link"><strong><code>RDB</code></strong></a>
to share non-code-related files around the RDB. Access is restricted to
project members only.</p></li>
<li><p>a dedicated <a href="https://en.wikipedia.org/wiki/Matrix_(protocol)" class="external-link">Matrix</a> chat
room <a href="https://matrix.to/#/#rdb:matrix.org" class="external-link"><strong>RDB</strong></a> for
ad-hoc communication (mainly in German) and an <a href="https://opentalk.eu/" class="external-link">OpenTalk</a> conference room <a href="https://opentalk.mailbox.org/invite/cd9de4a1-9279-4e2d-9888-f188de4a022e" class="external-link"><strong>RDB
Sync</strong></a> hosted on mailbox.org. Access to both is restricted to
project members only.</p></li>
</ul>
</div>
<div class="section level2">
<h2 id="comment-on-the-report">Comment on the report<a class="anchor" aria-label="anchor" href="#comment-on-the-report"></a>
</h2>
<div class="section level3">
<h3 id="interactively">Interactively<a class="anchor" aria-label="anchor" href="#interactively"></a>
</h3>
<p>For the <a href="https://report.rdb.vote/" class="external-link">published report</a>, the
<a href="https://en.wikipedia.org/wiki/Hypothes.is" class="external-link">Hypothes.is</a>
annotation system is integrated directly into the website<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Quarto provides &lt;a href="https://quarto.org/docs/output-formats/html-basics.html#commenting" class="external-link"&gt;built-in
Hypothes.is integration&lt;/a&gt;.&lt;/p&gt;'><sup>1</sup></a>. No additional browser
plug-in is required. Simply open the Hypothes.is sidebar by clicking the
<kbd>&lt;</kbd> button at the far right of the page to access the full
user interface.</p>
<p>Annotations (visible to others) and highlights (only visible to
yourself) can be made directly by selecting any text on the report
website. See <a href="https://web.hypothes.is/help/whats-the-difference-between-an-annotation-and-a-highlight/" class="external-link">this
help article</a> to learn more about the different types of annotations
that are supported.</p>
<p>Annotations are stored in the currently selected group. By default,
this is the world-readable group <a href="https://hypothes.is/groups/__world__/public?q=report.rdb.vote" class="external-link"><em>Public</em></a>.
But you can select any other group you’re a member of, as well as <em>🔒
Only Me</em> to keep an annotation private to yourself. For internal
review, we use the private group <a href="https://hypothes.is/groups/B8N5yjMP/rdb" class="external-link"><em>RDB</em></a>.</p>
<p>Annotations can be formatted via <a href="https://web.hypothes.is/help/formatting-annotations-with-markdown/" class="external-link">Markdown
syntax</a>.</p>
</div>
<div class="section level3">
<h3 id="via-e-mail">Via e-mail<a class="anchor" aria-label="anchor" href="#via-e-mail"></a>
</h3>
<p>We also invite our readers to provide feedback via e-mail to our
<code>feedback@</code> address which is an alias for the
<code>info@</code> mailbox. The webmail interface of this mailbox is
accessible <a href="https://webmail.gandi.net/SOGo/" class="external-link">here</a>. Login
credentials must be obtained from <a href="https://gitlab.com/salim-b" class="external-link">@salim-b</a>.</p>
</div>
</div>
<div class="section level2">
<h2 id="edit-the-report">Edit the report<a class="anchor" aria-label="anchor" href="#edit-the-report"></a>
</h2>
<p>The report is produced using the <a href="https://quarto.org/" class="external-link">Quarto</a> framework – the powerful successor
to the <a href="https://rmarkdown.rstudio.com/" class="external-link">R Markdown</a> format –
which comes as a <a href="https://quarto.org/docs/get-started/" class="external-link">CLI</a>
and an accompanying <a href="https://quarto.org/docs/tools/rstudio.html#r-package" class="external-link">R
package</a>.</p>
<p>The report’s Quarto project files are located at <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/" class="external-link"><code>input/report/</code></a>.</p>
<p>The <strong>main Quarto Markdown book chapter source files</strong>
are (relative to path <code>input/report/</code>):</p>
<ul>
<li>
<a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/index.qmd" class="external-link"><strong><code>index.qmd</code></strong></a>
(report’s landing page)</li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/index.qmd" class="external-link"><strong><code>national/CH/index.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/big_picture.qmd" class="external-link"><strong><code>national/CH/big_picture.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/n_referendums.qmd" class="external-link"><strong><code>national/CH/n_referendums.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/types.qmd" class="external-link"><strong><code>national/CH/types.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/topics.qmd" class="external-link"><strong><code>national/CH/topics.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/turnout.qmd" class="external-link"><strong><code>national/CH/turnout.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/outcomes.qmd" class="external-link"><strong><code>national/CH/outcomes.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/congruence.qmd" class="external-link"><strong><code>national/CH/congruence.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/national/CH/conclusion.qmd" class="external-link"><strong><code>national/CH/conclusion.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/index.qmd" class="external-link"><strong><code>overall/index.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/n_referendums_ballot_dates.qmd" class="external-link"><strong><code>overall/n_referendums_ballot_dates.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/trend_analysis.qmd" class="external-link"><strong><code>overall/trend_analysis.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/referendum_regime_type.qmd" class="external-link"><strong><code>overall/referendum_regime_type.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/turnout.qmd" class="external-link"><strong><code>overall/turnout.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/topics.qmd" class="external-link"><strong><code>overall/topics.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/glossary.qmd" class="external-link"><strong><code>glossary.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/bibliography.qmd" class="external-link"><strong><code>bibliography.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/imprint.qmd" class="external-link"><strong><code>imprint.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/hypothesis.qmd" class="external-link"><strong><code>hypothesis.qmd</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/tech.qmd" class="external-link"><strong><code>tech.qmd</code></strong></a></li>
</ul>
<p>The <em>rendered</em> report files are located at <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/output/report/" class="external-link"><code>output/report/</code></a>.
The published report available at <a href="https://report.rdb.vote/" class="external-link">report.rdb.vote</a> is directly deployed
from the <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/tree/master/output/report/" class="external-link">GitLab
repository’s <code>master</code> branch</a>. <strong><em>Please do not
stage and commit any files under the <code>output/</code> folder unless
you exactly know what you’re doing!</em></strong><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Usually, &lt;a href="https://gitlab.com/salim-b" class="external-link"&gt;@salim-b&lt;/a&gt; is responsible to update
the published report. Please contact him if in doubt.&lt;/p&gt;'><sup>2</sup></a></p>
<div class="section level3">
<h3 id="setup">Setup<a class="anchor" aria-label="anchor" href="#setup"></a>
</h3>
<p>To be able to work on the report, you either need an account<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Currently, accounts exist for &lt;a href="https://gitlab.com/jowuet" class="external-link"&gt;@jowuet&lt;/a&gt;, &lt;a href="https://gitlab.com/juriezzaini" class="external-link"&gt;@juriezzaini&lt;/a&gt;, &lt;a href="https://gitlab.com/polaris808" class="external-link"&gt;@polaris808&lt;/a&gt;, &lt;a href="https://gitlab.com/RobinTGut" class="external-link"&gt;@RobinTGut&lt;/a&gt;, &lt;a href="https://gitlab.com/the-schoscho" class="external-link"&gt;@the-schoscho&lt;/a&gt;, &lt;a href="https://gitlab.com/serdult" class="external-link"&gt;@serdult&lt;/a&gt; and &lt;a href="https://gitlab.com/zdaarau-salim" class="external-link"&gt;@zdaarau-salim&lt;/a&gt;.&lt;/p&gt;'><sup>3</sup></a> on our <a href="https://rstudio.rdb.vote/" class="external-link"><strong>preconfigured RStudio
Server</strong></a> (recommended)<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;The server VM is configured to automatically scale to
zero after the last user session is terminated. This means that the
whole VM is reset once the last user quits their session or is inactive
for more than 1 hour (after which their session is automatically
killed).&lt;/p&gt;
&lt;p&gt;Users &lt;strong&gt;should&lt;/strong&gt; make sure to &lt;strong&gt;commit and
push&lt;/strong&gt; their pending changes before quitting their session since
the Git repository clone on the RStudio Server is supposed to be reset
to a clean state regularly (i.e. on every VM update).&lt;/p&gt;
&lt;p&gt;In addition, it’s recommended to explicitly end the session when
finished working. To do so, simply press the red power-off button on the
top right and then close the web browser tab. This allows to save on
computing resources, i.e. energy. Otherwise, the VM will keep on running
for an additional hour.&lt;/p&gt;"><sup>4</sup></a> or set up the RStudio Desktop IDE<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;&lt;em&gt;IDE&lt;/em&gt; stands for &lt;em&gt;&lt;strong&gt;I&lt;/strong&gt;ntegrated
&lt;strong&gt;D&lt;/strong&gt;evelopment &lt;strong&gt;E&lt;/strong&gt;nvironment&lt;/em&gt;, a
software application that provides comprehensive facilities to computer
programmers for software development. More information can be found on
&lt;a href="https://en.wikipedia.org/wiki/Integrated_development_environment" class="external-link"&gt;Wikipedia&lt;/a&gt;.&lt;/p&gt;'><sup>5</sup></a> plus all
other requirements in your local environment according to the following
instructions.</p>
<details><summary>
Local setup instructions:
</summary><ol style="list-style-type: decimal">
<li>
<p><em>(optional, but recommended)</em> Install a package
manager.</p>
<ul>
<li>
<p><em>Windows</em>: Install <a href="https://learn.microsoft.com/windows/package-manager/" class="external-link"><strong>Windows
Package Manager (winget)</strong></a><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;There are other viable package managers available for
Windows, including &lt;a href="https://scoop.sh/" class="external-link"&gt;Scoop&lt;/a&gt; and &lt;a href="https://chocolatey.org/" class="external-link"&gt;Chocolatey&lt;/a&gt;. Packages available for
Scoop can be browsed &lt;a href="https://scoop.sh/#/apps" class="external-link"&gt;here&lt;/a&gt;, those
for Chocolatey &lt;a href="https://community.chocolatey.org/packages" class="external-link"&gt;here&lt;/a&gt;. While
Chocolatey has the larger user base, Scoop is technically &lt;a href="https://github.com/ScoopInstaller/Scoop/wiki/Chocolatey-and-Winget-Comparison" class="external-link"&gt;more
promising&lt;/a&gt; and its package repositories seem to be better
maintained.&lt;/p&gt;'><sup>6</sup></a>.</p>
<p>Available packages can be browsed <a href="https://winget.run/search" class="external-link">here</a>.</p>
</li>
<li>
<p><em>macOS</em>: Install <a href="https://brew.sh/" class="external-link"><strong>Homebrew</strong></a>.</p>
<p>Available packages can be browsed <a href="https://formulae.brew.sh/" class="external-link">here</a>.</p>
</li>
</ul>
<p><sub>Installing the software below via a package manager is by far
the most convenient choice, but of course you can also use other
installation methods.</sub></p>
</li>
<li>
<p>Install the <a href="https://git-scm.com/download/" class="external-link"><strong>Git</strong></a> version
control system.</p>
<ul>
<li><p>On Windows via winget: <a href="https://winget.run/pkg/Git/Git" class="external-link"><code>winget install --exact --id Git.Git</code></a></p></li>
<li><p>On macOS via Homebrew: <a href="https://formulae.brew.sh/formula/git" class="external-link"><code>brew install git</code></a></p></li>
</ul>
</li>
<li>
<p>Install the latest version of <a href="https://cloud.r-project.org/" class="external-link"><strong>R</strong></a>.</p>
<ul>
<li><p>On Windows via winget: <a href="https://winget.run/pkg/RProject/R" class="external-link"><code>winget install --exact --id RProject.R</code></a>
plus <a href="https://winget.run/pkg/RProject/Rtools" class="external-link"><code>winget install --exact --id RProject.Rtools</code></a></p></li>
<li><p>On macOS via Homebrew: <a href="https://formulae.brew.sh/formula/r" class="external-link"><code>brew install r</code></a></p></li>
</ul>
</li>
<li>
<p>Install the latest version of <a href="https://www.rstudio.com/products/rstudio/download/#download" class="external-link"><strong>RStudio</strong>
Desktop</a>.</p>
<ul>
<li><p>On Windows via winget: <a href="https://winget.run/pkg/RStudio/RStudio.OpenSource" class="external-link"><code>winget install --exact --id RStudio.RStudio.OpenSource</code></a></p></li>
<li><p>On macOS via Homebrew: <a href="https://formulae.brew.sh/cask/rstudio" class="external-link"><code>brew install --cask rstudio</code></a></p></li>
</ul>
</li>
<li>
<p>Install the latest version of <a href="https://quarto.org/docs/get-started/" class="external-link"><strong>Quarto</strong></a>.</p>
<ul>
<li><p>On Windows via winget: <a href="https://winget.run/pkg/RStudio/quarto" class="external-link"><code>winget install --exact --id RStudio.quarto</code></a></p></li>
<li><p>On macOS via Homebrew: <a href="https://formulae.brew.sh/cask/quarto" class="external-link"><code>brew install --cask quarto</code></a></p></li>
</ul>
</li>
<li>
<p>Install a <a href="https://en.wikipedia.org/wiki/TeX_Live" class="external-link">TeX
Live</a> distribution. It is strongly recommended to use <a href="https://yihui.org/tinytex/" class="external-link"><strong>TinyTeX</strong></a> since it
is small in size and allows missing LaTeX packages to be automatically
installed when rendering the report via RStudio.</p>
<p>For both Windows and macOS, refer to TinyTeX’s <a href="https://yihui.org/tinytex/#for-r-users" class="external-link">official installation
instructions</a>.</p>
</li>
<li>
<p>If not already done, create an <a href="https://docs.gitlab.com/ee/ssh/" class="external-link">SSH key</a>.</p>
<ul>
<li><p>On Windows: Set up SSH following <a href="https://blog.devgenius.io/set-up-ssh-key-and-git-integration-in-windows-10-native-way-c9b94952dd2c?gi=71c7f64d669d" class="external-link">this
tutorial</a>.</p></li>
<li><p>On macOS: Make sure to <a href="https://apple.stackexchange.com/a/250572" class="external-link">configure SSH to use the
system’s keychain</a>.</p></li>
</ul>
</li>
<li><p><a href="https://gitlab.com/users/sign_up" class="external-link">Create a GitLab
account</a> and <a href="https://gitlab.com/-/profile/keys" class="external-link">add your
public SSH key</a>.</p></li>
<li><p>Let <a href="https://gitlab.com/salim-b" class="external-link">@salim-b</a> give you <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/project_members" class="external-link">developer
access to this repository</a>.</p></li>
<li><p><a href="https://docs.gitlab.com/ee/gitlab-basics/start-using-git.html#clone-a-repository" class="external-link">Clone</a>
this repository using SSH to a local directory of your choice.</p></li>
<li>
<p>Open the report’s project file <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/report.Rproj" class="external-link"><code>input/report/report.Rproj</code></a>
in RStudio. <a href="#r-packages">renv’s private package library</a>
should be automatically populated during the first startup.</p>
<p>After that, everything should be ready. ✨</p>
<p>To later upgrade all of the software installed via the package
manager at once, run:</p>
<ul>
<li><p>On macOS: <a href="https://docs.brew.sh/FAQ#how-do-i-update-my-local-packages" class="external-link"><code>brew update; brew upgrade</code></a></p></li>
<li><p>On Windows: <a href="https://learn.microsoft.com/windows/package-manager/winget/upgrade" class="external-link"><code>winget upgrade --all</code></a></p></li>
</ul>
</li>
</ol></details>
</div>
<div class="section level3">
<h3 id="editor">Editor<a class="anchor" aria-label="anchor" href="#editor"></a>
</h3>
<p>For RStudio users it’s <strong>strongly recommended</strong> to start
by opening the RStudio project file <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/report.Rproj" class="external-link"><strong><code>report.Rproj</code></strong></a><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Otherwise, certain user interface elements like the
&lt;kbd&gt;Build Book&lt;/kbd&gt; button and &lt;a href="https://rstudio.github.io/visual-markdown-editing/citations.html#inserting-citations" class="external-link"&gt;RStudio’s
built-in citation insertion interface&lt;/a&gt; as well as other convenience
features won’t work as intended.&lt;/p&gt;'><sup>7</sup></a> which
happens automatically on login to our <a href="https://rstudio.rdb.vote/" class="external-link">preconfigured RStudio Server</a>.</p>
<p>Besides editing in raw source mode, RStudio users can optionally
switch to the <a href="https://rstudio.github.io/visual-markdown-editing/" class="external-link">visual
Markdown editing mode</a> which shows a semi-rendered <a href="https://en.wikipedia.org/wiki/WYSIWYG" class="external-link">WYSIWY<strong>G</strong></a>
view and offers a graphical user interface for the most widely used
parts of the Quarto Markdown syntax. But since the very idea of this
visual mode fundamentally breaks with Markdown’s <a href="https://en.wikipedia.org/wiki/WYSIWYM" class="external-link">WYSIWY<strong>M</strong></a>
paradigm, it’s recommended to be used with caution.</p>
<p>RStudio’s Markdown <a href="https://rstudio.github.io/visual-markdown-editing/markdown.html#canonical-mode" class="external-link">canonicalization</a>
is activated globally, meaning each time a (Quarto) Markdown document is
saved, it is normalized via a Pandoc<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;&lt;a href="https://pandoc.org/" class="external-link"&gt;Pandoc&lt;/a&gt;, a “universal
document converter”, is the software that also powers the rendering of
Quarto content to HTML, PDF, DOCX etc. output in the first place. Simply
put: It is one of the most underappreciated pieces of software out there
– and of course, it’s open source.&lt;/p&gt;'><sup>8</sup></a> “round trip” in the background. This
usually alters the formatting (but not the semantics), which can be
irritating at first. But the gained syntax standardization and visual
homogeneity far outweigh this disturbance. A detailed list of how
Markdown elements may be altered during canonicalization is found <a href="https://quarto.org/docs/visual-editor/markdown.html#overview" class="external-link">here</a>.</p>
</div>
<div class="section level3">
<h3 id="structure-and-metadata">Structure and metadata<a class="anchor" aria-label="anchor" href="#structure-and-metadata"></a>
</h3>
<p>We use a Quarto project of type <a href="https://quarto.org/docs/reference/projects/books.html" class="external-link"><strong>book</strong></a>
for the RDB report. The report’s metadata is specified via <a href="https://quarto.org/docs/projects/quarto-projects.html#shared-metadata" class="external-link">Quarto
project configuration file(s)</a> in <a href="https://en.wikipedia.org/wiki/YAML" class="external-link">YAML</a> format. Refer to
Quarto’s <a href="https://quarto.org/docs/reference/projects/books.html" class="external-link">book
options reference</a> for supported configuration values.</p>
<p>We specify multiple Quarto <a href="https://quarto.org/docs/projects/profiles.html" class="external-link">project
profiles</a> to flexibly generate different report versions from the
same content pool, depending on the output format (HTML, PDF etc.) and
the edition (i.e. publication year).</p>
<p>Currently, we have specified the Quarto profiles <code>web</code>,
<code>print</code>, <code>minimal</code> and <code>print_2023</code> via
the following <strong>Quarto profile configuration files</strong>
(relative to path <code>input/report/</code>):</p>
<ul>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto.yml" class="external-link"><strong><code>_quarto.yml</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-web.yml" class="external-link"><strong><code>_quarto-web.yml</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print.yml" class="external-link"><strong><code>_quarto-print.yml</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print_2023.yml" class="external-link"><strong><code>_quarto-print_2023.yml</code></strong></a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-minimal.yml" class="external-link"><strong><code>_quarto-minimal.yml</code></strong></a></li>
</ul>
<div class="section level4">
<h4 id="start-a-new-report-edition">Start a new report edition<a class="anchor" aria-label="anchor" href="#start-a-new-report-edition"></a>
</h4>
<p>To begin a new report edition<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;I.e. increase the publication year by 1.&lt;/p&gt;"><sup>9</sup></a>, follow these steps:</p>
<ol style="list-style-type: decimal">
<li>
<p>Create a new Quarto profile for the last edition’s
<code>print</code> version, so the PDF version of that edition can still
be rebuilt in case something needs correction.</p>
<p>To do so, create a new text file
<code>input/report/_quarto-print_YYYY.yml</code> where <code>YYYY</code>
corresponds to the last edition’s publication year. Copy all the
edition-specific metadata from <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto.yml?ref_type=heads" class="external-link"><code>input/report/_quarto.yml</code></a>
to that file<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;The metadata in &lt;code&gt;_quarto-print_YYYY.yml&lt;/code&gt;
takes precedence over and is complemented by the main
&lt;code&gt;_quarto.yml&lt;/code&gt; profile config file, as it is the case for all
profiles.&lt;/p&gt;"><sup>10</sup></a>. See <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print_2023.yml?ref_type=heads" class="external-link"><code>input/report/_quarto-print_2023.yml</code></a>
for an example.</p>
</li>
<li><p>Make the main <code>index.qmd</code> file(s) content of the
part(s) introduced in the new edition <a href="https://quarto.org/docs/authoring/conditional.html#matching-against-metadata" class="external-link">conditional</a>
on suitable <code>custom.incl_part_*</code> metadata. See <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/index.qmd?ref_type=heads" class="external-link"><code>input/report/overall/index.qmd</code></a>
for an example.</p></li>
<li><p>Update the main Quarto profile config file <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto.yml?ref_type=heads" class="external-link"><code>input/report/_quarto.yml</code></a>
to the new edition (authors, publication year etc.). Don’t forget to
update the <code>custom.incl_part_*</code> metadata<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;Only the part(s) introduced in the new edition should
be included by default.&lt;/p&gt;"><sup>11</sup></a>.</p></li>
<li>
<p>Update the <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-web.yml?ref_type=heads" class="external-link"><code>web</code></a>
and <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print.yml?ref_type=heads" class="external-link"><code>print</code></a>
Quarto profiles to include the new edition’s part(s) and chapters in the
correct order. The newest part(s), i.e. the one(s) introduced with the
new edition, should come <em>first</em>.</p>
<p>Don’t forget to add <code>custom.incl_part_*</code> metadata in the
<code>web</code> profile for the part(s) introduced in the new edition<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;The HTML version of the report is supposed to always
include all parts.&lt;/p&gt;"><sup>12</sup></a>.</p>
</li>
<li>
<p>Add a cover page for the new edition.</p>
<p>To do so, create a new file
<code>input/report/assets/cover_page_YYYY.odt</code> where
<code>YYYY</code> corresponds to the new edition’s publication year and
adapt it as needed. The most efficient way to do so is copy-pasting the
last edition’s cover page and updating it accordingly. When finished,
render that file to PDF (e.g. using <a href="https://libreoffice.org" class="external-link">LibreOffice</a>).</p>
</li>
</ol>
</div>
</div>
<div class="section level3">
<h3 id="code-chunk-options">Code chunk options<a class="anchor" aria-label="anchor" href="#code-chunk-options"></a>
</h3>
<p>To specify options that apply to a code chunk, like <a href="https://quarto.org/docs/computations/execution-options.html#output-options" class="external-link">output</a>,
<a href="https://quarto.org/docs/authoring/article-layout.html#code-cell-options" class="external-link">layout</a>
or <a href="https://quarto.org/docs/reference/cells/cells-knitr.html" class="external-link">knitr</a>
options, write them in special comments at the top of the code chunk,
e.g.:</p>
<div class="sourceCode" id="cb1"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="co">#| label: "fig-airquality"</span></span>
<span><span class="co">#| fig-cap: "Air Quality"</span></span>
<span><span class="co">#| fig-column: page</span></span></code></pre></div>
<p>The following code chunk options are set by default<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;These options are set in the &lt;a href="#structure-and-metadata"&gt;Quarto profile configuration files&lt;/a&gt;.&lt;/p&gt;'><sup>13</sup></a>, thus no need to
explicitly specify them:</p>
<table class="table">
<colgroup>
<col width="24%">
<col width="36%">
<col width="38%">
</colgroup>
<thead><tr class="header">
<th align="left"><strong>option</strong></th>
<th align="left"><strong>default value</strong></th>
<th align="left"><a href="https://rdb.report.rpkg.dev/reference/report_render#arg-profile"><strong>profiles</strong></a></th>
</tr></thead>
<tbody>
<tr class="odd">
<td align="left"><code>crop</code></td>
<td align="left"><code>FALSE</code></td>
<td align="left">
<code>"web"</code>, <code>"print"</code>
</td>
</tr>
<tr class="even">
<td align="left"><code>echo</code></td>
<td align="left"><code>FALSE</code></td>
<td align="left">
<code>"web"</code>, <code>"print"</code>
</td>
</tr>
<tr class="odd">
<td align="left"><code>message</code></td>
<td align="left"><code>FALSE</code></td>
<td align="left">
<code>"web"</code>, <code>"print"</code>
</td>
</tr>
<tr class="even">
<td align="left"><code>warning</code></td>
<td align="left"><code>FALSE</code></td>
<td align="left">
<code>"web"</code>, <code>"print"</code>
</td>
</tr>
<tr class="odd">
<td align="left"><code>out.width</code></td>
<td align="left"><code>"100%"</code></td>
<td align="left">
<code>"web"</code>, <code>"print"</code>
</td>
</tr>
<tr class="even">
<td align="left"><code>dev</code></td>
<td align="left"><code>"svglite"</code></td>
<td align="left"><code>"web"</code></td>
</tr>
<tr class="odd">
<td align="left"><code>dev.args</code></td>
<td align="left"><code>#f2f2f2</code></td>
<td align="left"><code>"web"</code></td>
</tr>
</tbody>
</table>
</div>
<div class="section level3">
<h3 id="cross-references">Cross references<a class="anchor" aria-label="anchor" href="#cross-references"></a>
</h3>
<p>Quarto enables you to create <a href="https://quarto.org/docs/authoring/cross-references.html" class="external-link">cross-references
to figures, tables, equations, sections, code listings, theorems,
proofs, and more</a>. RStudio’s visual Markdown editing mode offers a
convenient <a href="https://rstudio.github.io/visual-markdown-editing/markdown.html#cross-references" class="external-link">autocompletion</a>
feature based on all existing cross-referenceable labels<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Note that cross references only work with
&lt;em&gt;numbered&lt;/em&gt; navigation targets, which means &lt;a href="https://quarto.org/docs/authoring/cross-references.html#sections" class="external-link"&gt;&lt;code&gt;number-sections&lt;/code&gt;
must be set to &lt;code&gt;true&lt;/code&gt; for sections to be
cross-referenceable&lt;/a&gt;. This is the &lt;a href="https://quarto.org/docs/books/book-structure.html#chapter-numbers" class="external-link"&gt;default
for Quarto book&lt;/a&gt; projects.&lt;/p&gt;'><sup>14</sup></a>.</p>
<p>Examples of the most important cross reference types are given
below.</p>
<div class="section level4">
<h4 id="figures">Figures<a class="anchor" aria-label="anchor" href="#figures"></a>
</h4>
<p>To <a href="https://quarto.org/docs/authoring/cross-references.html#figures" class="external-link">refer
to a figure</a> labelled <code>fig-airquality</code> you simply
write:</p>
<pre class="rmd"><code><span><span class="va">See</span> <span class="op">@</span><span class="va">fig</span><span class="op">-</span><span class="va">airquality.</span></span></code></pre>
<p>To <a href="https://quarto.org/docs/authoring/cross-references.html#computations" class="external-link">refer
to a <em>sub</em>figure</a> you append the numerical subfigure rank to
the figure label. To refer to the first subfigure of a figure group
labelled <code>fig-airquality</code>, you write:</p>
<pre class="rmd"><code><span><span class="va">See</span> <span class="op">@</span><span class="va">fig</span><span class="op">-</span><span class="va">airquality</span><span class="op">-</span><span class="fl">1.</span></span></code></pre>
<p>See Quarto’s <a href="https://quarto.org/docs/authoring/cross-references.html#computations" class="external-link">documentation</a>
on how to create cross-referenceable figures from R code.</p>
</div>
<div class="section level4">
<h4 id="tables">Tables<a class="anchor" aria-label="anchor" href="#tables"></a>
</h4>
<p>To <a href="https://quarto.org/docs/authoring/cross-references.html#tables" class="external-link">refer
to a table</a> labelled <code>tbl-letters</code>, you analogously
write:</p>
<pre class="rmd"><code><span><span class="va">See</span> <span class="op">@</span><span class="va">tbl</span><span class="op">-</span><span class="va">letters.</span></span></code></pre>
<p>See Quarto’s <a href="https://quarto.org/docs/authoring/cross-references.html#computations-1" class="external-link">documentation</a>
on how to create cross-referenceable tables from R code.</p>
</div>
<div class="section level4">
<h4 id="sections">Sections<a class="anchor" aria-label="anchor" href="#sections"></a>
</h4>
<p>To <a href="https://quarto.org/docs/authoring/cross-references.html#sections" class="external-link">refer
to a <em>numbered</em> section</a> labelled <code>sec-intro</code>, you
analogously write:</p>
<pre class="rmd"><code><span><span class="va">See</span> <span class="op">@</span><span class="va">sec</span><span class="op">-</span><span class="va">intro.</span></span></code></pre>
<p>To label the section title with the ID <code>sec-intro</code>,
write:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode md"><code class="sourceCode markdown"><span id="cb6-1"><a href="#cb6-1" tabindex="-1"></a><span class="fu"># Introduction {#sec-intro}</span></span></code></pre></div>
<p>Note that currently only book <em>chapters</em> are
cross-referenceable, book <em>parts</em> are not.</p>
</div>
<div class="section level4">
<h4 id="arbitrary-elements">Arbitrary elements<a class="anchor" aria-label="anchor" href="#arbitrary-elements"></a>
</h4>
<p>To create <a href="https://quarto.org/docs/books/book-crossrefs.html#hyperlinks" class="external-link">hyperlinks</a>
(but not actual <em>cross references</em>) to elements that are not
covered by Quarto’s cross reference syntax, you can use standard
Markdown links to the relevant Quarto Markdown source file (and
fragment). To link to the term <em>World region</em> in our <a href="https://report.rdb.vote/glossary.html" class="external-link">glossary</a>, you could
write:</p>
<pre class="rmd"><code>The report's regional part is divided into [world regions](glossary.qmd#world-region).</code></pre>
<p>Note that we appended the fragment identifier
(<code>#world-region</code>) to the source file path
(<code>glossary.qmd</code>) in order to directly link to the exact place
in the glossary where <em>World region</em> is defined.</p>
<p>Such hyperlinks work in both HTML and PDF output. But in contrast to
actual Quarto cross references, these hyperlinks become useless when the
output document is printed since no human-parsable navigation hint is
generated (such as an element number like “Figure 4.2”).</p>
</div>
</div>
<div class="section level3">
<h3 id="citations-bibliography">Citations / Bibliography<a class="anchor" aria-label="anchor" href="#citations-bibliography"></a>
</h3>
<p>The bibliographic metadata for this report is stored in the public <a href="https://en.wikipedia.org/wiki/Zotero" class="external-link">Zotero</a> library <a href="https://www.zotero.org/groups/4604812/rdb_report/library" class="external-link"><strong><code>rdb_report</code></strong></a>.
Only group members have write access. We either set citation keys
manually for new items or rely on the Zotero add-on <a href="https://retorque.re/zotero-better-bibtex/" class="external-link">Better BibTeX (BBT)</a>
for <a href="https://retorque.re/zotero-better-bibtex/citing/" class="external-link">generation of
stable citation keys</a><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;We use BBT’s &lt;a href="https://retorque.re/zotero-better-bibtex/citing/#configurable-citekey-generator" class="external-link"&gt;default
&lt;code&gt;[auth:lower][shorttitle3_3][year]&lt;/code&gt; pattern&lt;/a&gt; for citation
key generation.&lt;/p&gt;
&lt;p&gt;To give some background on the whole citation standardization
situation:&lt;/p&gt;
&lt;p&gt;For the storage of bibliographic metadata in general and the citation
keys (or short “citekeys”) to identify individual bibliography items in
particular, only in recent years a well-defined and open standard has
become widely established: &lt;a href="https://github.com/citation-style-language/schema/#csl-json-schema" class="external-link"&gt;&lt;strong&gt;CSL-JSON&lt;/strong&gt;&lt;/a&gt;.
It offers i.a. a dedicated &lt;a href="https://github.com/citation-style-language/schema/blob/master/schemas/input/csl-data.json#L62-L64" class="external-link"&gt;&lt;code&gt;citation-key&lt;/code&gt;
field&lt;/a&gt; which &lt;a href="https://github.com/citation-style-language/schema/issues/243#issuecomment-643635052" class="external-link"&gt;differs
from the &lt;code&gt;id&lt;/code&gt; field&lt;/a&gt; in that it is meant for a
&lt;em&gt;locally&lt;/em&gt; unique identifier while the latter is designed to be a
&lt;a href="https://en.wikipedia.org/wiki/Universally_unique_identifier" class="external-link"&gt;&lt;em&gt;globally&lt;/em&gt;
unique identifier&lt;/a&gt; (for which considerably more entropy is required,
e.g. a 128-bit hash value, thus rendering it almost impossible to be
user-memorizable).&lt;/p&gt;
&lt;p&gt;Unfortunately, the development of Zotero’s internal metadata
structure predates CSL-JSON by more than a decade and there are
significant differences between the two. To convert from one to another,
non-trivial conversion steps are required. Specifically, Zotero has no
notion of &lt;em&gt;stable&lt;/em&gt; (and thus user-friendly) citation keys. Its
internal data model &lt;a href="https://forums.zotero.org/discussion/comment/318884/#Comment_318884" class="external-link"&gt;doesn’t
(yet) have a native field for them&lt;/a&gt; like CSL-JSON does with
&lt;code&gt;citation-key&lt;/code&gt;. Instead, Zotero auto-generates the keys only
during export based on bibliography data like an author name or title
and offers the user no means to customize them.&lt;/p&gt;
&lt;p&gt;Solving these issues has presumably been neglected in Zotero’s
development because its main target user group relies on &lt;a href="https://en.wikipedia.org/wiki/WYSIWYG" class="external-link"&gt;WYSIWY&lt;strong&gt;G&lt;/strong&gt;&lt;/a&gt;
editors like LibreOffice or Microsoft Word and their respective Zotero
plugins which use other means to identify individual bibliography items.
In contrast, &lt;a href="https://en.wikipedia.org/wiki/WYSIWYM" class="external-link"&gt;WYSIWY&lt;strong&gt;M&lt;/strong&gt;&lt;/a&gt;
editors – or more precisely their underlying syntaxes like LaTeX or &lt;a href="https://pandoc.org/MANUAL.html#pandocs-markdown" class="external-link"&gt;(Pandoc’s)
Markdown&lt;/a&gt; which properly separate content from presentation – solely
rely on (user-memorizable) citation keys like
&lt;code&gt;greenFewThoughtsSignal2020&lt;/code&gt; as identifiers for bibliography
items, hence they must only change on user request after the item’s
initial creation.&lt;/p&gt;
&lt;p&gt;This is where BBT shines: It extends Zotero with the ability to
create stable citation keys, besides offering other enhancements
tailored to WYSIWYM users.&lt;/p&gt;'><sup>15</sup></a>. Citation keys are stored (“pinned”)<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;BBT by default only “pins” citation keys on explicit
request but there’s a &lt;a href="https://retorque.re/zotero-better-bibtex/installation/preferences/#automatically-pin-citation-key-after" class="external-link"&gt;separate
configuration option to automatically pin citation keys after the chosen
amount of seconds&lt;/a&gt; which we recommend to set to the value
&lt;code&gt;3&lt;/code&gt; (meaning the citation key is automatically pinned 3
seconds after an item’s creation).&lt;/p&gt;'><sup>16</sup></a> in the
<code>Extra</code> field<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;Identified by the prefix &lt;code&gt;Citation Key:&lt;/code&gt; and
separated from other content in the same field by simple newlines
(&lt;code&gt;\n&lt;/code&gt;).&lt;/p&gt;"><sup>17</sup></a> of an item.</p>
<p>The whole <code>rdb_report</code> Zotero group library is exported to
the CSL-JSON file <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/assets/bibliography.json" class="external-link"><code>assets/bibliography.json</code></a>
via <a href="https://rdb.report.rpkg.dev/reference/report_update_bib.html"><code>report_update_bib()</code></a>,
which is executed every time the report is <a href="#render-the-report">rendered</a>. This file is then referenced as
bibliographic metadata source in the Quarto configuration.</p>
<p>Citations can be inserted using <a href="https://quarto.org/docs/authoring/footnotes-and-citations.html#sec-citations" class="external-link">Pandoc’s
citation syntax</a>. RStudio’s offers a very convenient <a href="https://rstudio.github.io/visual-markdown-editing/citations.html#inserting-citations" class="external-link">citation
insertion feature</a> which allows to search the whole bibliography and
offers citation key autocompletion. Unfortunately, it’s only available
in <a href="https://rstudio.github.io/visual-markdown-editing/" class="external-link">visual
Markdown editing mode</a> and not (yet) in source editing mode.</p>
<p>To format citation references, the <a href="https://en.wikipedia.org/wiki/Citation_Style_Language" class="external-link">citation
style</a> <em>Chicago Manual of Style 17th edition (author-date)</em>
(<a href="https://github.com/citation-style-language/styles/blob/v1.0.2/chicago-author-date.csl" class="external-link"><code>chicago-author-date</code></a>)
is used. This style also defines how the titles of the cited literature
are formatted, based on their language codes (set in the
<code>Language</code> field): For all items with an <code>en</code>
language code set, titles are automatically formatted in <a href="https://en.wikipedia.org/wiki/Title_case" class="external-link">title case</a>. The same
applies to items without an explicit language code set (<code>en</code>
is assumed in that case). For all other languages, titles are formatted
as-is, i.e. as written in the Zotero library.</p>
<p>To manually control how titles are formatted, you can resort to a <a href="https://www.zotero.org/support/kb/rich_text_bibliography" class="external-link">set of
specific HTML tags</a>. The automatic title-casing can be avoided by
wrapping text in
<code>&lt;span class="nocase"&gt;...&lt;/span&gt;</code>. This allows to
e.g. correctly format a German title in an English Zotero item.</p>
</div>
<div class="section level3">
<h3 id="language-style">Language style<a class="anchor" aria-label="anchor" href="#language-style"></a>
</h3>
<div class="section level4">
<h4 id="capitalization-of-titles">Capitalization of titles<a class="anchor" aria-label="anchor" href="#capitalization-of-titles"></a>
</h4>
<p>We do <em>not</em> use <a href="https://en.wikipedia.org/wiki/Title_case" class="external-link">title case</a>, partly
because the corresponding rules <a href="https://en.wikipedia.org/wiki/Letter_case#Headings_and_publication_titles" class="external-link">are
not universally standardized</a>. Instead, we write titles like the rest
of the text in <a href="https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage" class="external-link">sentence
case</a>, something that, for example, also the International
Organization for Standardization does in its own publications.</p>
</div>
</div>
<div class="section level3">
<h3 id="r-packages">R packages<a class="anchor" aria-label="anchor" href="#r-packages"></a>
</h3>
<p>To provide a reproducible R environment including the exact version
of all necessary R packages, we rely on <a href="https://rstudio.github.io/renv/articles/renv.html" class="external-link">renv</a>.</p>
<p>We use renv’s <a href="https://rstudio.github.io/renv/reference/snapshot.html#snapshot-type" class="external-link"><code>"explicit"</code>
snapshot type</a> in which the following steps are required in order to
introduce a new R package dependency <code>PKG_NAME</code>:</p>
<ol style="list-style-type: decimal">
<li><p>Add <code>PKG_NAME</code> including possible remotes to the <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/DESCRIPTION" class="external-link">report’s
<code>DESCRIPTION</code> file</a>.</p></li>
<li>
<p>Run in an R console:</p>
<div class="sourceCode" id="cb8"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">renv</span><span class="fu">::</span><span class="fu"><a href="https://rstudio.github.io/renv/reference/install.html" class="external-link">install</a></span><span class="op">(</span><span class="st">"PKG_NAME"</span>,</span>
<span>              prompt <span class="op">=</span> <span class="cn">FALSE</span>,</span>
<span>              lock <span class="op">=</span> <span class="cn">TRUE</span><span class="op">)</span></span></code></pre></div>
</li>
</ol>
<p>The project’s renv snapshot state will be <a href="https://rstudio.github.io/renv/reference/restore.html" class="external-link">restored</a>
during R session initialization, i.e. when executing the report’s <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/.Rprofile" class="external-link"><code>.Rprofile</code>
file</a>, so no manual action is required by collaborators to bring
their renv libraries up to date. Depending on the extent of snapshot
changes, this can take a considerable amount of time (up to several
minutes). The following message displayed on the console will indicate
when renv project restoral is completed:</p>
<pre><code>✔ Restoring renv state done. Ready to go.</code></pre>
</div>
</div>
<div class="section level2">
<h2 id="render-the-report">Render the report<a class="anchor" aria-label="anchor" href="#render-the-report"></a>
</h2>
<p>To view the rendered report locally, e.g. to preview recent edits, <a href="https://quarto.org/docs/get-started/hello/text-editor.html#authoring" class="external-link"><code>quarto preview</code></a>
or <a href="https://quarto.org/docs/projects/quarto-projects.html#rendering-projects" class="external-link"><code>quarto render</code></a>
must be executed. The former is intended for continuously previewing the
report locally and continues running Quarto in the background after the
initial render phase to automatically rebuild affected parts of the
report when input files change<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;Everytime an input file or document resource (e.g. CSS)
is changed on disk (i.e. saved), the corresponding chapter is rebuilt
and the browser window is automatically reloaded.&lt;/p&gt;"><sup>18</sup></a>. RStudio’s built-in <kbd>Render</kbd>
button on open <code>.qmd</code> files as well as the <kbd>Render
Book</kbd> button in the <kbd>Build</kbd> pane both launch
<code>quarto preview</code> in the background<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;&lt;code&gt;quarto preview&lt;/code&gt; can also be launched via
&lt;code&gt;quarto::quarto_preview(file = rdb.report::path_pkg_repo("input/report"))&lt;/code&gt;.
It can be stopped again via &lt;code&gt;&lt;a href="https://quarto-dev.github.io/quarto-r/reference/quarto_preview.html" class="external-link"&gt;quarto::quarto_preview_stop()&lt;/a&gt;&lt;/code&gt;
or by restarting the R session.&lt;/p&gt;'><sup>19</sup></a>.</p>
<p>Unfortunately, even partial rendering is often too slow for Quarto’s
preview functionality to feel like an actual real-time editing
experience. So we recommend to avoid it and instead call our custom
RStudio add-ins <em>on demand</em> that execute <a href="https://rdb.report.rpkg.dev/reference/report_render"><code>rdb.report::report_render()</code></a>
and <a href="https://rdb.report.rpkg.dev/reference/report_render_partly"><code>rdb.report::report_render_partly()</code></a>
which run <code>quarto render</code> without launching a continuous
preview.</p>
<p>Another shortcoming of RStudio’s Quarto integration is that it
doesn’t allow to choose the Quarto profile, meaning the
<kbd>Render</kbd> and <kbd>Render Book</kbd> buttons will always only
render the <em>default</em><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;Which profile is default is defined in
&lt;code&gt;_quarto.yml&lt;/code&gt; (the first element of
&lt;code&gt;profile.group&lt;/code&gt;), currently this is the
&lt;strong&gt;&lt;code&gt;web&lt;/code&gt;&lt;/strong&gt; profile.&lt;/p&gt;"><sup>20</sup></a> profile. The arrow next to each of the
render buttons only allows to select the <em>output format</em><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Corresponding to &lt;code&gt;&lt;a href="https://quarto-dev.github.io/quarto-r/reference/quarto_render.html" class="external-link"&gt;quarto::quarto_render()&lt;/a&gt;&lt;/code&gt;’s
&lt;a href="https://quarto-dev.github.io/quarto-r/reference/quarto_render.html#arg-output-format" class="external-link"&gt;&lt;code&gt;output_format&lt;/code&gt;&lt;/a&gt;
parameter.&lt;/p&gt;'><sup>21</sup></a>, but
not the <em>profile</em>. Unfortunately, the two concepts are somewhat
orthogonal to each other.</p>
<p>In our case, however, we only ever want to render a profile to one
specific output format (<code>web</code> to HTML, <code>print</code> to
PDF), but Quarto does not allow to assign a specific output format to a
profile or anything like that. Therefore,
<code><a href="../reference/report_render.html">rdb.report::report_render()</a></code> contains some additional logic
to automatically select our desired output format if it is not
explicitly specified<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;I.e. if &lt;a href="https://rdb.report.rpkg.dev/reference/report_render#arg-output-format"&gt;&lt;code&gt;output_format = NULL&lt;/code&gt;&lt;/a&gt;&lt;/p&gt;'><sup>22</sup></a>.</p>
<p>Finally, note that rendering the report writes the output to
<code>output/report/</code>. The <a href="https://report.rdb.vote/" class="external-link">report.rdb.vote</a> website is deployed
from <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/tree/master/output/report" class="external-link">this
subdirectory of the GitLab remote</a>. Thus, <strong>commiting and
pushing changes under <code>output/report/</code> directly updates the
live report</strong>.</p>
<div class="section level3">
<h3 id="complete-render">Complete render<a class="anchor" aria-label="anchor" href="#complete-render"></a>
</h3>
<p>To re-render the full report to HTML, either invoke the
<kbd><em>Render report to HTML</em></kbd> command via RStudio’s <a href="https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts" class="external-link">command
palette</a><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;On Linux and Windows, the default shortcut to open
RStudio’s command palette is
&lt;kbd&gt;Ctrl&lt;/kbd&gt;+&lt;kbd&gt;Shift&lt;/kbd&gt;+&lt;kbd&gt;P&lt;/kbd&gt;, while on macOS the
default is &lt;kbd&gt;Cmd&lt;/kbd&gt;+&lt;kbd&gt;Shift&lt;/kbd&gt;+&lt;kbd&gt;P&lt;/kbd&gt;. Note that on
the &lt;a href="https://rstudio.rdb.vote/" class="external-link"&gt;RDB RStudio Server&lt;/a&gt;, the
shortcut is &lt;kbd&gt;Ctrl&lt;/kbd&gt;+&lt;kbd&gt;P&lt;/kbd&gt; by default.&lt;/p&gt;'><sup>23</sup></a> or run the following command directly
from any R console with its <a href="https://rdrr.io/r/base/getwd.html" class="external-link">working directory</a> set to a
(sub)path of this repository:</p>
<div class="sourceCode" id="cb10"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_render.html">report_render</a></span><span class="op">(</span>profile <span class="op">=</span> <span class="st">"web"</span><span class="op">)</span></span></code></pre></div>
<p>Or – since <code>profile = "web"</code> is the default – just:</p>
<div class="sourceCode" id="cb11"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_render.html">report_render</a></span><span class="op">(</span><span class="op">)</span></span></code></pre></div>
<p>To render to PDF instead, run</p>
<div class="sourceCode" id="cb12"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_render.html">report_render</a></span><span class="op">(</span>profile <span class="op">=</span> <span class="st">"print"</span><span class="op">)</span></span></code></pre></div>
</div>
<div class="section level3">
<h3 id="partial-render">Partial render<a class="anchor" aria-label="anchor" href="#partial-render"></a>
</h3>
<p>Quarto supports <a href="https://quarto.org/docs/projects/code-execution.html#incremental-render" class="external-link">incremental
rendering</a> for HTML output<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Unfortunately, incremental rendering is not supported
for PDF output. This means that if you instruct Quarto to only render a
single chapter to PDF (e.g. via
&lt;code&gt;rdb.report::report_render_partly(path = rdb.report::path_pkg_repo("input/report/intro.qmd"), profile = "print")&lt;/code&gt;),
the entire report will still be rendered.&lt;/p&gt;'><sup>24</sup></a>. This allows to quickly iterate on the
report by only re-rendering the chapter or part you’re currently working
on.</p>
<p>To re-render the currently opened file, invoke the <kbd><em>Render
report partly to HTML</em></kbd> command via RStudio’s command
palette.</p>
<p>You can also re-render a single report chapter or part directly from
any R console with its <a href="https://rdrr.io/r/base/getwd.html" class="external-link">working directory</a> set to a
(sub)path of this repository. To re-render e.g. just the <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall" class="external-link"><strong><code>overall</code></strong></a>
part, run:</p>
<div class="sourceCode" id="cb13"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_render_partly.html">report_render_partly</a></span><span class="op">(</span>path <span class="op">=</span> <span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/path_pkg_repo.html">path_pkg_repo</a></span><span class="op">(</span><span class="st">"input/report/overall"</span><span class="op">)</span><span class="op">)</span></span></code></pre></div>
</div>
<div class="section level3">
<h3 id="static-preview">Static preview<a class="anchor" aria-label="anchor" href="#static-preview"></a>
</h3>
<p>To view the rendered<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Meaning the files under &lt;a href="output/report/"&gt;&lt;code&gt;output/report/&lt;/code&gt;&lt;/a&gt;.&lt;/p&gt;'><sup>25</sup></a> report <em>immediately</em> from any R
console with its <a href="https://rdrr.io/r/base/getwd.html" class="external-link">working
directory</a> set to a (sub)path of this repository, run:</p>
<div class="sourceCode" id="cb14"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_view.html">report_view</a></span><span class="op">(</span><span class="op">)</span></span></code></pre></div>
<p>By default, the HTML version is opened, in RStudio’s viewer pane if
available<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;Of course, the preview can be accessed using any
(reasonably up-to-date) web browser by opening &lt;a href="http://127.0.0.1:3456" class="external-link uri"&gt;http://127.0.0.1:3456&lt;/a&gt;
(&lt;code&gt;3456&lt;/code&gt; is the default port which can be changed via the &lt;a href="https://rdb.report.rpkg.dev/reference/report_view#arg-port"&gt;&lt;code&gt;port&lt;/code&gt;
argument&lt;/a&gt;).&lt;/p&gt;'><sup>26</sup></a>.</p>
<p>Alternatively, you can also invoke the <kbd><em>View report in
HTML</em></kbd> command via RStudio’s <a href="https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts" class="external-link">command
palette</a>.</p>
<p>Note that on RStudio <em>Server</em>, it might happen from time to
time that an error message <code>Connection refused</code> instead of
the actual HTML version of the report is displayed. While the exact
cause of this issue is still unknown to us<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content="&lt;p&gt;My best guess would be that it’s related to some
premature token expiration.&lt;/p&gt;"><sup>27</sup></a>, it can simply be
remedied via a <a href="https://www.howtogeek.com/672607/how-to-hard-refresh-your-web-browser-to-bypass-your-cache/" class="external-link"><em>hard
refresh</em> of the web browser</a>, after which
<code><a href="../reference/report_view.html">rdb.report::report_view()</a></code> works as expected again.</p>
<p>To view the PDF version instead, run:</p>
<div class="sourceCode" id="cb15"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/report_view.html">report_view</a></span><span class="op">(</span>profile <span class="op">=</span> <span class="st">"print"</span><span class="op">)</span></span></code></pre></div>
<p>Note that this does <em>not</em> automatically re-render content on
changes. Use <a href="#render-the-report">Quarto’s preview
functionality</a> if you’d like that instead.</p>
</div>
</div>
<div class="section level2">
<h2 id="update-report-assets">Update report assets<a class="anchor" aria-label="anchor" href="#update-report-assets"></a>
</h2>
<p>Certain files required to build the report are only manually
updated.</p>
<p>To update the Pandoc LaTeX template to the <a href="https://gitlab.com/salim_b/pandoc/templates/" class="external-link">latest version</a>,
run:</p>
<div class="sourceCode" id="cb16"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">salim</span><span class="fu">::</span><span class="fu"><a href="https://salim.rpkg.dev/reference/pandoc_tpl.html" class="external-link">pandoc_tpl</a></span><span class="op">(</span>tpl <span class="op">=</span> <span class="st">"quarto_mod.latex"</span><span class="op">)</span> <span class="op">|&gt;</span> <span class="fu">brio</span><span class="fu">::</span><span class="fu"><a href="https://brio.r-lib.org/reference/write_file.html" class="external-link">write_file</a></span><span class="op">(</span>path <span class="op">=</span> <span class="fu">rdb.report</span><span class="fu">::</span><span class="fu"><a href="../reference/path_pkg_repo.html">path_pkg_repo</a></span><span class="op">(</span><span class="st">"input/report/assets/template.latex"</span><span class="op">)</span><span class="op">)</span></span></code></pre></div>
</div>
<div class="section level2">
<h2 id="analytics">Analytics<a class="anchor" aria-label="anchor" href="#analytics"></a>
</h2>
<p>To measure the number and origin of visitors to the report website,
we use the non-privacy-invading open source analytics service <a href="https://counter.dev/" class="external-link">Counter</a>. The service doesn’t collect or
store any personal information from visitors and there are no cookies
involved.</p>
<p>Guest access to the analytics dashboard is activated. It is
accessible under <a href="https://counter.dev/dashboard.html?user=rdb.vote&amp;token=L8SkjwQUvR4%3D" class="external-link"><strong>this
URL</strong></a>.</p>
</div>

  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside>
</div>



    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann, Uwe Serdült.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer>
</div>





  </body>
</html>
